﻿#ifndef RESPONSEUTILITY_H
#define RESPONSEUTILITY_H

#include <string_view>

namespace ResponseUtility {
/**
 * @brief Return a reasonable mime type based on the extension of a file.
 */
std::string_view mimeType(std::string_view path);

/**
 * @brief Append an HTTP rel-path to a local filesystem path.The returned path is normalized for the
 * platform.
 */
std::string pathCat(std::string_view base, std::string_view path);
} // namespace ResponseUtility

#endif // RESPONSEUTILITY_H
